; GPS Logger
; T. Nakagawa
; 2008/08/26-10/26

; CPU frequency: 1MHz

; RXD: GPS
; TXD: PC
; PD2: switch
; PA1: CLE
; PA0: ALE
; PD3: _CE_
; PD4: _WE_
; PD5: _RE_
; PD6: LED
; PB0-7: D0-7

;  0         1         2         3         4         5         6         7         8
;  0123456789012345678901234567890123456789012345678901234567890123456789012345678901234
; "$GPGGA,hhmmss.sss,ddmm.mmmm,n,dddmm.mmmm,e,v,ss,dd.d,hhhhh.h,M,gggg.g,M,xxx.x,0000*hh"

.include "tn2313def.inc"

.def	logint	= r16	; MOԊu(bɋL^邩)
.def	cnt_sw	= r17	; XCb`b
.def	ptrl	= r18	; tbV̎ɏރy[W(ʃAhX)
.def	ptrh	= r19	; tbV̎ɏރy[W(ʃAhX)
.def	pagecnt	= r20	; SM̃y[Wɏ񂾉

.equ	PORT_LED	= PORTD
.equ	BIT_LED		= PORTD6
.equ	PORT_SWITCH	= PIND
.equ	BIT_SWITCH	= PIND2
.equ	PORT_SM_CLE	= PORTA
.equ	BIT_SM_CLE	= PORTA1
.equ	PORT_SM_ALE	= PORTA
.equ	BIT_SM_ALE	= PORTA0
.equ	PORT_SM_CE	= PORTD
.equ	BIT_SM_CE	= PORTD3
.equ	PORT_SM_WE	= PORTD
.equ	BIT_SM_WE	= PORTD4
.equ	PORT_SM_RE	= PORTD
.equ	BIT_SM_RE	= PORTD5
.equ	PORT_SM_OUT	= PORTB
.equ	PORT_SM_IN	= PINB
.equ	DDR_SM_OUT	= DDRB
.equ	BUFSIZE		= 87	; Mobt@̃TCY
.equ	BUFSIZE2	= 51	; f[^WJobt@̃TCY
.equ	LOG_INT		= 1	; MOԊu
.equ	CNT_ERASE	= (5 + 1)	; NÂ߂ɃXCb`(+1b)
.equ	CNT_SEND	= (2 + 1)	; f[^M̂߂ɃXCb`(+1b)

.cseg
.org	0

; Interruption Vector
	rjmp	reset	; RESET
	reti
	reti
	reti
	reti
	reti
	reti
	rjmp	recv	; USART RX
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti

; reset
reset:
	; initialize stack
	ldi	ZL, LOW(RAMEND)
	out	SPL, ZL
	; initialize PORT
	ldi	ZL, 0b00000011
	out	DDRA, ZL
	ldi	ZL, 0b00000000
	out	DDRB, ZL
	ldi	ZL, 0b01111000
	out	DDRD, ZL
	ldi	ZL, 0b01111100
	out	PORTD, ZL
	; initialize analog comparator
	ldi	ZL, 0b10000000
	out	ACSR, ZL
	; enable sleep
	ldi	ZL, 0b00100000
	out	MCUCR, ZL
	; initialize USART
	ldi	ZL, HIGH(12)	; 9600bps@1MHz(x2)
	out	UBRRH, ZL
	ldi	ZL, LOW(12)
	out	UBRRL, ZL
	ldi	ZL, (EXP2(U2X))
	out	UCSRA, ZL
	ldi	ZL, (EXP2(RXCIE) | EXP2(RXEN) | EXP2(TXEN))
	out	UCSRB, ZL
	; initialize
	ldi	XL, LOW(SRAM_START)
	ldi	XH, HIGH(SRAM_START)
	ldi	cnt_sw, 0

; Main
	sbic	PORT_SWITCH, BIT_SWITCH
	rjmp	log

; Mouse-mode
mouse:
	cbi	PORT_LED, BIT_LED	; LED on
	ldi	cnt_sw, 1
mouse1:	sei
	sleep
	cli
	brcc	mouse1
	; XCb`̏ԊmF
	cpi	cnt_sw, 0
	breq	mouse2
	sbic	PORT_SWITCH, BIT_SWITCH
	rjmp	mouse2
	inc	cnt_sw
	rjmp	mouse3
mouse2:	ldi	cnt_sw, 0
mouse3:	cpi	cnt_sw, CNT_ERASE
	breq	erase
	; UARTւGPGGȀo
mouse4:	ld	ZL, X+
	rcall	putc
	cpi	XL, LOW(SRAM_START + 87)
	brne	mouse4
	ldi	XL, LOW(SRAM_START)
	ldi	XH, HIGH(SRAM_START)
	rjmp	mouse1

; tbV̏
erase:
	ser	ZL
	rcall	sm_enable
	; A
	ldi	YL, 0x00
	ldi	YH, 0x00
erase3:	ldi	ZL, 0x60
	rcall	sm_wcmd
	mov	ZL, YL
	rcall	sm_wadr
	mov	ZL, YH
	rcall	sm_wadr
	ldi	ZL, 0xd0
	rcall	sm_wcmd
	; >5ms@1MHz̃EFCg
	ldi	ZH, 7
erase1:	ldi	ZL, 255
erase2:	dec	ZL
	brne	erase2
	dec	ZH
	brne	erase1
	; JԂ
	adiw	YL, 1
	cpi	YH, 0x04
	brne	erase3
	clr	ZL
	rcall	sm_enable
	sbi	PORT_LED, BIT_LED	; LED off
erase4:	rjmp	erase4	; [v

; Logger-mode
log:
	ldi	logint, LOG_INT
	rcall	mem_seek	; 󂫗̈T
log1:	sei
	sleep
	cli
	brcc	log1
	inc	cnt_sw
	sbic	PORT_SWITCH, BIT_SWITCH
	ldi	cnt_sw, 0
	cpi	cnt_sw, CNT_SEND
	breq	send
	; MO
	dec	logint
	brne	log1
	cbi	PORT_LED, BIT_LED	; LED on
	ldi	logint, LOG_INT
	rcall	cmpr	; f[^k
	rcall	mem_store	; tbVɕۑ
	ldi	XL, LOW(SRAM_START)
	ldi	XH, HIGH(SRAM_START)
	sbi	PORT_LED, BIT_LED	; LED off
	rjmp	log1

; tbV̓ePC֑M
send:
	cbi	PORT_LED, BIT_LED	; LED on
	ser	ZL
	rcall	sm_enable
	ldi	ZL, 0x00	; ǂݍރy[WAhX
	ldi	ZH, 0x00
send0:	cp	ZL, ptrl
	brne	send2
	cp	ZH, ptrh
	brne	send2
	; I
	clr	ZL
	rcall	sm_enable
	sbi	PORT_LED, BIT_LED	; LED off
send1:	rjmp	send1	; [v
send2:	; SmartMediãy[Wǂݍ݂Əo
	push	ZL
	push	ZH
	push	ZL
	ldi	ZL, 0x00
	rcall	sm_wcmd
	ldi	ZL, 0x00
	rcall	sm_wadr
	pop	ZL
	rcall	sm_wadr
	mov	ZL, ZH
	rcall	sm_wadr
	rcall	sm_wait
	ldi	ZH, 22
send3:	push	ZH
	rcall	mem_read	; tbV24bytesǂݍ
	rcall	expd	; f[^̓WJE`Eo
	pop	ZH
	dec	ZH
	brne	send3
	pop	ZH
	pop	ZL
	adiw	ZL, 1
	rjmp	send0

; obt@GPGGAf[^̈k(87->24bytes)
cmpr:
	; GPGGA̐`
	;; Rs[(sv폜)(XH:XL->YH:YL)
	ldi	XH, HIGH(SRAM_START + 7)	; 擪7oCgXLbv
	ldi	XL, LOW(SRAM_START + 7)
	ldi	YL, LOW(SRAM_START)
	ldi	YH, HIGH(SRAM_START)
cmpr3:	cpi	XL, LOW(SRAM_START + 77)	; `FbNT
	brne	cmpr3c
	adiw	XL, 6	; ",0000*"̃XLbv
	ld	ZL, X+
	cpi	ZL, ('9' + 1)
	brcs	cmpr3a
	subi	ZL, -(-'A' + '9' + 1)
cmpr3a:	st	Y+, ZL
	ld	ZL, X+
	cpi	ZL, ('9' + 1)
	brcs	cmpr3b
	subi	ZL, -(-'A' + '9' + 1)
cmpr3b:	st	Y+, ZL
	rjmp	cmpr4	; I
cmpr3c:	cpi	XL, LOW(SRAM_START + 28)	; N/S
	brne	cmpr3d
	ld	ZL, X+
	bst	ZL, 0
	clr	ZH
	bld	ZH, 3
cmpr3d:	cpi	XL, LOW(SRAM_START + 41)	; E/W,v,s
	brne	cmpr3e
	ld	ZL, X+	; E/W
	bst	ZL, 1
	bld	ZH, 2
	adiw	XL, 1	; ,
	ld	ZL, X+	; v
	bst	ZL, 0
	bld	ZH, 1
	adiw	XL, 1	; ,
	ld	ZL, X+	; s
	bst	ZL, 0
	bld	ZH, 0
	st	Y+, ZH
cmpr3e:	ld	ZL, X+
	cpi	ZL, ','	; ȊÕXLbv
	breq	cmpr3
	cpi	ZL, '.'
	breq	cmpr3
	cpi	ZL, 'M'
	breq	cmpr3
	st	Y+, ZL
	rjmp	cmpr3
cmpr4:	;; ʃrbĝăTCY𔼕ɋl߂(XH:XL->YH:YL)
	ldi	XL, LOW(SRAM_START)
	ldi	XH, HIGH(SRAM_START)
	ldi	YL, LOW(SRAM_START)
	ldi	YH, HIGH(SRAM_START)
cmpr5:	cpi	XL, LOW(SRAM_START + 48)	; I
	breq	cmpr6
	ld	ZL, X+
	andi	ZL, 0x0f
	swap	ZL
	ld	ZH, X+
	andi	ZH, 0x0f
	or	ZL, ZH
	st	Y+, ZL
	rjmp	cmpr5
cmpr6:	ret

; f[^̓WJ(SRAM_STARTɑ݂錳f[^(24bytes)SRAM_STARTɓWJ(87bytes))
expd:
	; ꎞ̈ɃRs[
	ldi	XL, LOW(SRAM_START)
	ldi	XH, HIGH(SRAM_START)
	ldi	YL, LOW(SRAM_START + BUFSIZE2)
	ldi	YH, HIGH(SRAM_START + BUFSIZE2)
expd0:	cpi	XL, LOW(SRAM_START + 24)
	breq	expd1
	ld	ZL, X+
	st	Y+, ZL
	rjmp	expd0
expd1:	; ASCIIւ̓WJ(XH:XL->YH:YL)
	ldi	XL, LOW(SRAM_START + BUFSIZE2)
	ldi	XH, HIGH(SRAM_START + BUFSIZE2)
	ldi	YL, LOW(SRAM_START)
	ldi	YH, HIGH(SRAM_START)
expd2:	cpi	XL, LOW(SRAM_START + BUFSIZE2 + 24)
	breq	expd3
	ld	ZL, X+
	mov	ZH, ZL
	swap	ZL
	andi	ZL, 0x0f
	ori	ZL, ('0' & 0xf0)
	andi	ZH, 0x0f
	ori	ZH, ('0' & 0xf0)
	cpi	XL, LOW(SRAM_START + BUFSIZE2 + 8 + 1)	; m,N/S,d
	brne	expd2a
	st	Y+, ZL
	ldi	ZL, 0	; dummy
expd2a:	cpi	XL, LOW(SRAM_START + BUFSIZE2 + 13 + 1)	; (N/S),e,v,ss
	brne	expd2b
	push	ZH
	ldi	ZH, 'N'
	bst	ZL, 3
	bld	ZH, 0
	sbiw	YL, 10
	st	Y, ZH	; N/S
	adiw	YL, 10
	ldi	ZH, 'E'
	bst	ZL, 2
	bld	ZH, 1
	st	Y+, ZH	; E/W
	ldi	ZH, '0'
	bst	ZL, 1
	bld	ZH, 0
	st	Y+, ZH	; v
	ldi	ZH, '0'
	bst	ZL, 0
	bld	ZH, 0
	mov	ZL, ZH
	pop	ZH
expd2b:	cpi	XL, LOW(SRAM_START + BUFSIZE2 + 23 + 1)	; hh
	brne	expd2d
	cpi	ZL, ('9' + 1)
	brcs	expd2c
	subi	ZL, -(-('9' + 1) + 'A')
expd2c:	cpi	ZH, ('9' + 1)
	brcs	expd2d
	subi	ZH, -(-('9' + 1) + 'A')
expd2d:	cpi	ZL, '='	; '-'̏
	brne	expd2e
	ldi	ZL, '-'
expd2e:	cpi	ZH, '='
	brne	expd2f
	ldi	ZH, '-'
expd2f:	st	Y+, ZL	; 
	st	Y+, ZH
	rjmp	expd2
	; `UARTɏo
expd3:	ldi	XL, LOW(SRAM_START)
	ldi	XH, HIGH(SRAM_START)
	ldi	ZL, LOW(2 * fmttbl)
	ldi	ZH, HIGH(2 * fmttbl)
expd4:	lpm	YL, Z+
	push	ZL
	mov	ZL, YL
	cpi	ZL, '@'
	brne	expd4a
	ld	ZL, X+
expd4a:	rcall	putc
	pop	ZL
	cpi	ZL, LOW(2 * fmttbl + 87)
	brne	expd4
	ret

; tbV̋󂫗̈Tď݂̏
mem_seek:
	ldi	YL, 0x00	; y[WAhX
	ldi	YH, 0x00
	ser	ZL
	rcall	sm_enable
mseek0:	ldi	ZL, 0x00
	rcall	sm_wcmd
	ldi	ZL, 0x00
	rcall	sm_wadr
	mov	ZL, YL
	rcall	sm_wadr
	mov	ZL, YH
	rcall	sm_wadr
	rcall	sm_wait
	cbi	PORT_SM_RE, BIT_SM_RE
	nop
	in	ZL, PORT_SM_IN
	sbi	PORT_SM_RE, BIT_SM_RE
	nop
	cpi	ZL, 0xff
	breq	mseek2
	adiw	YL, 1
	cpi	YH, 0x04
	breq	mseek2
	rjmp	mseek0
mseek2:	; 󂫗̈悪̏
	mov	ptrl, YL
	mov	ptrh, YH
	ldi	pagecnt, 0	; y[W̏ݐJE^̏
	; ݏ
	ldi	ZL, 0x80
	rcall	sm_wcmd
	ldi	ZL, 0x00
	rcall	sm_wadr
	mov	ZL, YL
	rcall	sm_wadr
	mov	ZL, YH
	rcall	sm_wadr
	rcall	sm_wait
	clr	ZL
	rcall	sm_enable
	ret

mem_store:
	ser	ZL
	rcall	sm_enable
	ldi	ZH, 0xff
	out	DDR_SM_OUT, ZH
	ldi	XL, LOW(SRAM_START)
	ldi	XH, HIGH(SRAM_START)
mstr0:	cpi	XL, LOW(SRAM_START + 24)
	breq	mstr1
	ld	ZL, X+
	out	PORT_SM_OUT, ZL
	cbi	PORT_SM_WE, BIT_SM_WE
	nop
	sbi	PORT_SM_WE, BIT_SM_WE
	nop
	rjmp	mstr0
mstr1:	ldi	ZH, 0x00
	out	DDR_SM_OUT, ZH
	out	PORT_SM_OUT, ZH
	inc	pagecnt
	cpi	pagecnt, 22
	brne	mstr3
	; 1y[W̏
	ldi	ZL, 0x10
	rcall	sm_wcmd
	; wait(>500us)
	ldi	ZL, 50
mstr2:	rcall	sm_wait
	dec	ZL
	brne	mstr2
	; ݂̏̏
	mov	YL, ptrl
	mov	YH, ptrh
	adiw	YL, 1
	mov	ptrl, YL
	mov	ptrh, YH
	ldi	ZL, 0x80
	rcall	sm_wcmd
	ldi	ZL, 0x00
	rcall	sm_wadr
	mov	ZL, YL
	rcall	sm_wadr
	mov	ZL, YH
	rcall	sm_wadr
	rcall	sm_wait
	ldi	pagecnt, 0
mstr3:	clr	ZL
	rcall	sm_enable
	ret

; tbV24bytes̃f[^SRAM_STARTɓǂݍ
mem_read:
	ldi	YL, LOW(SRAM_START)
	ldi	YH, HIGH(SRAM_START)
mread0:	cpi	YL, LOW(SRAM_START + 24)
	brne	mread1
	ret
mread1:	cbi	PORT_SM_RE, BIT_SM_RE
	nop
	in	ZL, PORT_SM_IN
	sbi	PORT_SM_RE, BIT_SM_RE
	nop
	st	Y+, ZL
	rjmp	mread0

; UART RX interruption
; SRAM_STARTBUFSIZEobt@ɕۑDGPGGA̓͂ƃL[𗧂Ă
recv:
	; ǂݍ
	cpi	XL, LOW(SRAM_START + BUFSIZE)
	brne	recv1
	sbiw	XL, 1
recv1:	in	ZL, UDR
	st	X+, ZL
	; '\n'ǂ̃`FbN
	cpi	ZL, 0x0a
	breq	recv2
recv0:	clc
recv3:	reti
recv2:	; GPGGAǂ̃`FbN
	ldi	XL, LOW(SRAM_START)
	ldi	XH, HIGH(SRAM_START)
	adiw	XL, 4
	ld	ZL, X
	sbiw	XL, 4
	cpi	ZL, 'G'	; GPGGA?
	brne	recv0
	sec
	reti

; UARTւ̈ꕶo
putc:
	sbis	UCSRA, UDRE
	rjmp	putc
	out	UDR, ZL
	ret

; SmartMediachip enable(ZL=0disableCȊOenable)
sm_enable:
	tst	ZL
	breq	sme0
	cbi	PORT_SM_CE, BIT_SM_CE
	ret
sme0:	sbi	PORT_SM_CE, BIT_SM_CE
	ret

; SmartMediãR}h
sm_wcmd:
	push	ZH
	sbi	PORT_SM_CLE, BIT_SM_CLE
	nop
	ldi	ZH, 0xff
	out	DDR_SM_OUT, ZH
	out	PORT_SM_OUT, ZL
	nop
	cbi	PORT_SM_WE, BIT_SM_WE
	nop
	sbi	PORT_SM_WE, BIT_SM_WE
	nop
	ldi	ZH, 0x00
	out	DDR_SM_OUT, ZH
	out	PORT_SM_OUT, ZH
	cbi	PORT_SM_CLE, BIT_SM_CLE
	nop
	pop	ZH
	ret

; SmartMediãAhX
sm_wadr:
	push	ZH
	sbi	PORT_SM_ALE, BIT_SM_ALE
	nop
	ldi	ZH, 0xff
	out	DDR_SM_OUT, ZH
	out	PORT_SM_OUT, ZL
	nop
	cbi	PORT_SM_WE, BIT_SM_WE
	nop
	sbi	PORT_SM_WE, BIT_SM_WE
	nop
	ldi	ZH, 0x00
	out	DDR_SM_OUT, ZH
	out	PORT_SM_OUT, ZH
	cbi	PORT_SM_ALE, BIT_SM_ALE
	nop
	pop	ZH
	ret

; >10us̃EFCg
sm_wait:
	push	ZL
	ldi	ZL, 4
swait0:	dec	ZL
	brne	swait0
	pop	ZL
	ret

fmttbl:
.db	"$GPGGA,@@@@@@.@@@,@@@@.@@@@,@,@@@@@.@@@@,@,@,@@,@@.@,@@@@@.@,M,@@@@.@,M,@@@.@,0000*@@", 0x0d, 0x0a, 0
